提交 5b85143b 编写于 作者: J Junio C Hamano

Merge branch 'ew/svn-pm'

* ew/svn-pm:
  git-svn: rename 'commit' command to 'set-tree'
  git-svn: remove support for the svn command-line client
  git-svn: convert to using Git.pm
......@@ -64,7 +64,7 @@ manually joining branches on commit.
against the latest changes in the SVN repository.
An optional command-line argument may be specified as an
alternative to HEAD.
This is advantageous over 'commit' (below) because it produces
This is advantageous over 'set-tree' (below) because it produces
cleaner, more linear history.
'log'::
......@@ -89,7 +89,7 @@ manually joining branches on commit.
Any other arguments are passed directly to `git log'
'commit'::
'set-tree'::
You should consider using 'dcommit' instead of this command.
Commit specified commit or tree objects to SVN. This relies on
your imported fetch data being up-to-date. This makes
......@@ -172,7 +172,7 @@ This can allow you to make partial mirrors when running fetch.
-::
--stdin::
Only used with the 'commit' command.
Only used with the 'set-tree' command.
Read a list of commits from stdin and commit them in reverse
order. Only the leading sha1 is read from each line, so
......@@ -180,7 +180,7 @@ git-rev-list --pretty=oneline output can be used.
--rmdir::
Only used with the 'dcommit', 'commit' and 'commit-diff' commands.
Only used with the 'dcommit', 'set-tree' and 'commit-diff' commands.
Remove directories from the SVN tree if there are no files left
behind. SVN can version empty directories, and they are not
......@@ -193,7 +193,7 @@ repo-config key: svn.rmdir
-e::
--edit::
Only used with the 'dcommit', 'commit' and 'commit-diff' commands.
Only used with the 'dcommit', 'set-tree' and 'commit-diff' commands.
Edit the commit message before committing to SVN. This is off by
default for objects that are commits, and forced on when committing
......@@ -204,7 +204,7 @@ repo-config key: svn.edit
-l<num>::
--find-copies-harder::
Only used with the 'dcommit', 'commit' and 'commit-diff' commands.
Only used with the 'dcommit', 'set-tree' and 'commit-diff' commands.
They are both passed directly to git-diff-tree see
gitlink:git-diff-tree[1] for more information.
......@@ -276,7 +276,7 @@ ADVANCED OPTIONS
-b<refname>::
--branch <refname>::
Used with 'fetch', 'dcommit' or 'commit'.
Used with 'fetch', 'dcommit' or 'set-tree'.
This can be used to join arbitrary git branches to remotes/git-svn
on new commits where the tree object is equivalent.
......@@ -392,11 +392,11 @@ REBASE VS. PULL
---------------
Originally, git-svn recommended that the remotes/git-svn branch be
pulled from. This is because the author favored 'git-svn commit B'
to commit a single head rather than the 'git-svn commit A..B' notation
pulled from. This is because the author favored 'git-svn set-tree B'
to commit a single head rather than the 'git-svn set-tree A..B' notation
to commit multiple commits.
If you use 'git-svn commit A..B' to commit several diffs and you do not
If you use 'git-svn set-tree A..B' to commit several diffs and you do not
have the latest remotes/git-svn merged into my-branch, you should use
'git rebase' to update your work branch instead of 'git pull'. 'pull'
can cause non-linear history to be flattened when committing into SVN,
......
......@@ -32,40 +32,30 @@
);
sub fatal (@) { print STDERR @_; exit 1 }
# If SVN:: library support is added, please make the dependencies
# optional and preserve the capability to use the command-line client.
# use eval { require SVN::... } to make it lazy load
# We don't use any modules not in the standard Perl distribution:
require SVN::Core; # use()-ing this causes segfaults for me... *shrug*
require SVN::Ra;
require SVN::Delta;
if ($SVN::Core::VERSION lt '1.1.0') {
fatal "Need SVN::Core 1.1.0 or better (got $SVN::Core::VERSION)\n";
}
push @SVN::Git::Editor::ISA, 'SVN::Delta::Editor';
push @SVN::Git::Fetcher::ISA, 'SVN::Delta::Editor';
*SVN::Git::Fetcher::process_rm = *process_rm;
use Carp qw/croak/;
use IO::File qw//;
use File::Basename qw/dirname basename/;
use File::Path qw/mkpath/;
use Getopt::Long qw/:config gnu_getopt no_ignore_case auto_abbrev pass_through/;
use File::Spec qw//;
use File::Copy qw/copy/;
use POSIX qw/strftime/;
use IPC::Open3;
use Memoize;
use Git qw/command command_oneline command_noisy
command_output_pipe command_input_pipe command_close_pipe/;
memoize('revisions_eq');
memoize('cmt_metadata');
memoize('get_commit_time');
my ($SVN, $_use_lib);
sub nag_lib {
print STDERR <<EOF;
! Please consider installing the SVN Perl libraries (version 1.1.0 or
! newer). You will generally get better performance and fewer bugs,
! especially if you:
! 1) have a case-insensitive filesystem
! 2) replace symlinks with files (and vice-versa) in commits
EOF
}
$_use_lib = 1 unless $ENV{GIT_SVN_NO_LIB};
libsvn_load();
nag_lib() unless $_use_lib;
my ($SVN);
my $_optimize_commits = 1 unless $ENV{GIT_SVN_NO_OPTIMIZE_COMMITS};
my $sha1 = qr/[a-f\d]{40}/;
......@@ -82,7 +72,7 @@ sub nag_lib {
$_username, $_config_dir, $_no_auth_cache, $_xfer_delta,
$_pager, $_color);
my (@_branch_from, %tree_map, %users, %rusers, %equiv);
my ($_svn_co_url_revs, $_svn_pg_peg_revs, $_svn_can_do_switch);
my ($_svn_can_do_switch);
my @repo_path_split_cache;
my %fc_opts = ( 'no-ignore-externals' => \$_no_ignore_ext,
......@@ -117,7 +107,12 @@ sub nag_lib {
init => [ \&init, "Initialize a repo for tracking" .
" (requires URL argument)",
\%init_opts ],
commit => [ \&commit, "Commit git revisions to SVN",
dcommit => [ \&dcommit, 'Commit several diffs to merge with upstream',
{ 'merge|m|M' => \$_merge,
'strategy|s=s' => \$_strategy,
'dry-run|n' => \$_dry_run,
%cmt_opts } ],
'set-tree' => [ \&commit, "Set an SVN repository to a git tree-ish",
{ 'stdin|' => \$_stdin, %cmt_opts, %fc_opts, } ],
'show-ignore' => [ \&show_ignore, "Show svn:ignore listings",
{ 'revision|r=i' => \$_revision } ],
......@@ -160,11 +155,6 @@ sub nag_lib {
'file|F=s' => \$_file,
'revision|r=s' => \$_revision,
%cmt_opts } ],
dcommit => [ \&dcommit, 'Commit several diffs to merge with upstream',
{ 'merge|m|M' => \$_merge,
'strategy|s=s' => \$_strategy,
'dry-run|n' => \$_dry_run,
%cmt_opts } ],
);
my $cmd;
......@@ -191,7 +181,6 @@ sub nag_lib {
init_vars();
load_authors() if $_authors;
load_all_refs() if $_branch_all_refs;
svn_compat_check() unless $_use_lib;
migration_check() unless $cmd =~ /^(?:init|rebuild|multi-init|commit-diff)$/;
$cmd{$cmd}->[0]->(@ARGV);
exit 0;
......@@ -232,28 +221,27 @@ sub version {
}
sub rebuild {
if (quiet_run(qw/git-rev-parse --verify/,"refs/remotes/$GIT_SVN^0")) {
if (!verify_ref("refs/remotes/$GIT_SVN^0")) {
copy_remote_ref();
}
$SVN_URL = shift or undef;
my $newest_rev = 0;
if ($_upgrade) {
sys('git-update-ref',"refs/remotes/$GIT_SVN","$GIT_SVN-HEAD");
command_noisy('update-ref',"refs/remotes/$GIT_SVN","
$GIT_SVN-HEAD");
} else {
check_upgrade_needed();
}
my $pid = open(my $rev_list,'-|');
defined $pid or croak $!;
if ($pid == 0) {
exec("git-rev-list","refs/remotes/$GIT_SVN") or croak $!;
}
my ($rev_list, $ctx) = command_output_pipe("rev-list",
"refs/remotes/$GIT_SVN");
my $latest;
while (<$rev_list>) {
chomp;
my $c = $_;
croak "Non-SHA1: $c\n" unless $c =~ /^$sha1$/o;
my @commit = grep(/^git-svn-id: /,`git-cat-file commit $c`);
my @commit = grep(/^git-svn-id: /,
command(qw/cat-file commit/, $c));
next if (!@commit); # skip merges
my ($url, $rev, $uuid) = extract_metadata($commit[$#commit]);
if (!defined $rev || !$uuid) {
......@@ -279,33 +267,7 @@ sub rebuild {
print "r$rev = $c\n";
$newest_rev = $rev if ($rev > $newest_rev);
}
close $rev_list or croak $?;
goto out if $_use_lib;
if (!chdir $SVN_WC) {
svn_cmd_checkout($SVN_URL, $latest, $SVN_WC);
chdir $SVN_WC or croak $!;
}
$pid = fork;
defined $pid or croak $!;
if ($pid == 0) {
my @svn_up = qw(svn up);
push @svn_up, '--ignore-externals' unless $_no_ignore_ext;
sys(@svn_up,"-r$newest_rev");
$ENV{GIT_INDEX_FILE} = $GIT_SVN_INDEX;
index_changes();
exec('git-write-tree') or croak $!;
}
waitpid $pid, 0;
croak $? if $?;
out:
if ($_upgrade) {
print STDERR <<"";
Keeping deprecated refs/head/$GIT_SVN-HEAD for now. Please remove it
when you have upgraded your tools and habits to use refs/remotes/$GIT_SVN
}
command_close_pipe($rev_list, $ctx);
}
sub init {
......@@ -323,10 +285,10 @@ sub init {
$SVN_URL = $url;
unless (-d $GIT_DIR) {
my @init_db = ('git-init-db');
my @init_db = ('init-db');
push @init_db, "--template=$_template" if defined $_template;
push @init_db, "--shared" if defined $_shared;
sys(@init_db);
command_noisy(@init_db);
}
setup_git_svn();
}
......@@ -334,70 +296,13 @@ sub init {
sub fetch {
check_upgrade_needed();
$SVN_URL ||= file_to_s("$GIT_SVN_DIR/info/url");
my $ret = $_use_lib ? fetch_lib(@_) : fetch_cmd(@_);
if ($ret->{commit} && quiet_run(qw(git-rev-parse --verify
refs/heads/master^0))) {
sys(qw(git-update-ref refs/heads/master),$ret->{commit});
my $ret = fetch_lib(@_);
if ($ret->{commit} && !verify_ref('refs/heads/master^0')) {
command_noisy(qw(update-ref refs/heads/master),$ret->{commit});
}
return $ret;
}
sub fetch_cmd {
my (@parents) = @_;
my @log_args = -d $SVN_WC ? ($SVN_WC) : ($SVN_URL);
unless ($_revision) {
$_revision = -d $SVN_WC ? 'BASE:HEAD' : '0:HEAD';
}
push @log_args, "-r$_revision";
push @log_args, '--stop-on-copy' unless $_no_stop_copy;
my $svn_log = svn_log_raw(@log_args);
my $base = next_log_entry($svn_log) or croak "No base revision!\n";
# don't need last_revision from grab_base_rev() because
# user could've specified a different revision to skip (they
# didn't want to import certain revisions into git for whatever
# reason, so trust $base->{revision} instead.
my (undef, $last_commit) = svn_grab_base_rev();
unless (-d $SVN_WC) {
svn_cmd_checkout($SVN_URL,$base->{revision},$SVN_WC);
chdir $SVN_WC or croak $!;
read_uuid();
$last_commit = git_commit($base, @parents);
assert_tree($last_commit);
} else {
chdir $SVN_WC or croak $!;
read_uuid();
# looks like a user manually cp'd and svn switch'ed
unless ($last_commit) {
sys(qw/svn revert -R ./);
assert_svn_wc_clean($base->{revision});
$last_commit = git_commit($base, @parents);
assert_tree($last_commit);
}
}
my @svn_up = qw(svn up);
push @svn_up, '--ignore-externals' unless $_no_ignore_ext;
my $last = $base;
while (my $log_msg = next_log_entry($svn_log)) {
if ($last->{revision} >= $log_msg->{revision}) {
croak "Out of order: last >= current: ",
"$last->{revision} >= $log_msg->{revision}\n";
}
# Revert is needed for cases like:
# https://svn.musicpd.org/Jamming/trunk (r166:167), but
# I can't seem to reproduce something like that on a test...
sys(qw/svn revert -R ./);
assert_svn_wc_clean($last->{revision});
sys(@svn_up,"-r$log_msg->{revision}");
$last_commit = git_commit($log_msg, $last_commit, @parents);
$last = $log_msg;
}
close $svn_log->{fh};
$last->{commit} = $last_commit;
return $last;
}
sub fetch_lib {
my (@parents) = @_;
$SVN_URL ||= file_to_s("$GIT_SVN_DIR/info/url");
......@@ -416,16 +321,16 @@ sub fetch_lib {
read_uuid();
if (defined $last_commit) {
unless (-e $GIT_SVN_INDEX) {
sys(qw/git-read-tree/, $last_commit);
command_noisy('read-tree', $last_commit);
}
chomp (my $x = `git-write-tree`);
my ($y) = (`git-cat-file commit $last_commit`
my $x = command_oneline('write-tree');
my ($y) = (command(qw/cat-file commit/, $last_commit)
=~ /^tree ($sha1)/m);
if ($y ne $x) {
unlink $GIT_SVN_INDEX or croak $!;
sys(qw/git-read-tree/, $last_commit);
command_noisy('read-tree', $last_commit);
}
chomp ($x = `git-write-tree`);
$x = command_oneline('write-tree');
if ($y ne $x) {
print STDERR "trees ($last_commit) $y != $x\n",
"Something is seriously wrong...\n";
......@@ -489,45 +394,19 @@ sub commit {
}
my @revs;
foreach my $c (@commits) {
chomp(my @tmp = safe_qx('git-rev-parse',$c));
my @tmp = command('rev-parse',$c);
if (scalar @tmp == 1) {
push @revs, $tmp[0];
} elsif (scalar @tmp > 1) {
push @revs, reverse (safe_qx('git-rev-list',@tmp));
push @revs, reverse(command('rev-list',@tmp));
} else {
die "Failed to rev-parse $c\n";
}
}
chomp @revs;
$_use_lib ? commit_lib(@revs) : commit_cmd(@revs);
commit_lib(@revs);
print "Done committing ",scalar @revs," revisions to SVN\n";
}
sub commit_cmd {
my (@revs) = @_;
chdir $SVN_WC or croak "Unable to chdir $SVN_WC: $!\n";
my $info = svn_info('.');
my $fetched = fetch();
if ($info->{Revision} != $fetched->{revision}) {
print STDERR "There are new revisions that were fetched ",
"and need to be merged (or acknowledged) ",
"before committing.\n";
exit 1;
}
$info = svn_info('.');
read_uuid($info);
my $last = $fetched;
foreach my $c (@revs) {
my $mods = svn_checkout_tree($last, $c);
if (scalar @$mods == 0) {
print "Skipping, no changes detected\n";
next;
}
$last = svn_commit_tree($last, $c);
}
}
sub commit_lib {
my (@revs) = @_;
my ($r_last, $cmt_last) = svn_grab_base_rev();
......@@ -606,10 +485,10 @@ sub commit_lib {
sub dcommit {
my $head = shift || 'HEAD';
my $gs = "refs/remotes/$GIT_SVN";
chomp(my @refs = safe_qx(qw/git-rev-list --no-merges/, "$gs..$head"));
my @refs = command(qw/rev-list --no-merges/, "$gs..$head");
my $last_rev;
foreach my $d (reverse @refs) {
if (quiet_run('git-rev-parse','--verify',"$d~1") != 0) {
if (!verify_ref("$d~1")) {
die "Commit $d\n",
"has no parent commit, and therefore ",
"nothing to diff against.\n",
......@@ -633,7 +512,7 @@ sub dcommit {
}
return if $_dry_run;
fetch();
my @diff = safe_qx('git-diff-tree', $head, $gs);
my @diff = command('diff-tree', $head, $gs, '--');
my @finish;
if (@diff) {
@finish = qw/rebase/;
......@@ -645,37 +524,11 @@ sub dcommit {
"Resetting to the latest $gs\n";
@finish = qw/reset --mixed/;
}
sys('git', @finish, $gs);
command_noisy(@finish, $gs);
}
sub show_ignore {
$SVN_URL ||= file_to_s("$GIT_SVN_DIR/info/url");
$_use_lib ? show_ignore_lib() : show_ignore_cmd();
}
sub show_ignore_cmd {
require File::Find or die $!;
if (defined $_revision) {
die "-r/--revision option doesn't work unless the Perl SVN ",
"libraries are used\n";
}
chdir $SVN_WC or croak $!;
my %ign;
File::Find::find({wanted=>sub{if(lstat $_ && -d _ && -d "$_/.svn"){
s#^\./##;
@{$ign{$_}} = svn_propget_base('svn:ignore', $_);
}}, no_chdir=>1},'.');
print "\n# /\n";
foreach (@{$ign{'.'}}) { print '/',$_ if /\S/ }
delete $ign{'.'};
foreach my $i (sort keys %ign) {
print "\n# ",$i,"\n";
foreach (@{$ign{$i}}) { print '/',$i,'/',$_ if /\S/ }
}
}
sub show_ignore_lib {
my $repo;
$SVN ||= libsvn_connect($SVN_URL);
my $r = defined $_revision ? $_revision : $SVN->get_latest_revnum;
......@@ -689,7 +542,7 @@ sub graft_branches {
if (%$grafts) {
# temporarily disable our grafts file to make this idempotent
chomp($gr_sha1 = safe_qx(qw/git-hash-object -w/,$gr_file));
chomp($gr_sha1 = command(qw/hash-object -w/,$gr_file));
rename $gr_file, "$gr_file~$gr_sha1" or croak $!;
}
......@@ -707,11 +560,7 @@ sub graft_branches {
}
}
unless ($_no_graft_copy) {
if ($_use_lib) {
graft_file_copy_lib($grafts,$l_map,$u);
} else {
graft_file_copy_cmd($grafts,$l_map,$u);
}
graft_file_copy_lib($grafts,$l_map,$u);
}
}
graft_tree_joins($grafts);
......@@ -743,7 +592,7 @@ sub multi_init {
unless (-d $GIT_SVN_DIR) {
print "GIT_SVN_ID set to 'trunk' for $_trunk\n" if $ch_id;
init($_trunk);
sys('git-repo-config', 'svn.trunk', $_trunk);
command_noisy('repo-config', 'svn.trunk', $_trunk);
}
complete_url_ls_init($url, $_branches, '--branches/-b', '');
complete_url_ls_init($url, $_tags, '--tags/-t', 'tags/');
......@@ -781,11 +630,8 @@ sub show_log {
}
config_pager();
my $pid = open(my $log,'-|');
defined $pid or croak $!;
if (!$pid) {
exec(git_svn_log_cmd($r_min,$r_max), @args) or croak $!;
}
@args = (git_svn_log_cmd($r_min, $r_max), @args);
my $log = command_output_pipe(@args);
run_pager();
my (@k, $c, $d);
......@@ -832,7 +678,7 @@ sub show_log {
process_commit($_, $r_min, $r_max) foreach reverse @k;
}
out:
close $log;
eval { command_close_pipe($log) };
print '-' x72,"\n" unless $_incremental || $_oneline;
}
......@@ -842,10 +688,6 @@ sub commit_diff_usage {
}
sub commit_diff {
if (!$_use_lib) {
print STDERR "commit-diff must be used with SVN libraries\n";
exit 1;
}
my $ta = shift or commit_diff_usage();
my $tb = shift or commit_diff_usage();
if (!eval { $SVN_URL = shift || file_to_s("$GIT_SVN_DIR/info/url") }) {
......@@ -912,7 +754,7 @@ sub cmt_showable {
return 1 if defined $c->{r};
if ($c->{l} && $c->{l}->[-1] eq "...\n" &&
$c->{a_raw} =~ /\@([a-f\d\-]+)>$/) {
my @msg = safe_qx(qw/git-cat-file commit/, $c->{c});
my @msg = command(qw/cat-file commit/, $c->{c});
shift @msg while ($msg[0] ne "\n");
shift @msg;
@{$c->{l}} = grep !/^git-svn-id: /, @msg;
......@@ -961,7 +803,7 @@ sub log_use_color {
sub git_svn_log_cmd {
my ($r_min, $r_max) = @_;
my @cmd = (qw/git-log --abbrev-commit --pretty=raw
my @cmd = (qw/log --abbrev-commit --pretty=raw
--default/, "refs/remotes/$GIT_SVN");
push @cmd, '-r' unless $_non_recursive;
push @cmd, qw/--raw --name-status/ if $_verbose;
......@@ -1046,8 +888,7 @@ sub complete_url_ls_init {
}
$var = $url . $var;
}
chomp(my @ls = $_use_lib ? libsvn_ls_fullurl($var)
: safe_qx(qw/svn ls --non-interactive/, $var));
my @ls = libsvn_ls_fullurl($var);
my $old = $GIT_SVN;
defined(my $pid = fork) or croak $!;
if (!$pid) {
......@@ -1071,7 +912,7 @@ sub complete_url_ls_init {
waitpid $pid, 0;
croak $? if $?;
my ($n) = ($switch =~ /^--(\w+)/);
sys('git-repo-config', "svn.$n", $var);
command_noisy('repo-config', "svn.$n", $var);
}
sub common_prefix {
......@@ -1103,11 +944,8 @@ sub graft_tree_joins {
git_svn_each(sub {
my $i = shift;
defined(my $pid = open my $fh, '-|') or croak $!;
if (!$pid) {
exec qw/git-rev-list --pretty=raw/,
"refs/remotes/$i" or croak $!;
}
my @args = (qw/rev-list --pretty=raw/, "refs/remotes/$i");
my ($fh, $ctx) = command_output_pipe(@args);
while (<$fh>) {
next unless /^commit ($sha1)$/o;
my $c = $1;
......@@ -1130,9 +968,7 @@ sub graft_tree_joins {
foreach my $p (@{$tree_map{$t}}) {
next if $p eq $c;
my $mb = eval {
safe_qx('git-merge-base', $c, $p)
};
my $mb = eval { command('merge-base', $c, $p) };
next unless ($@ || $?);
if (defined $r_a) {
# see if SVN says it's a relative
......@@ -1161,41 +997,10 @@ sub graft_tree_joins {
# what should we do when $ct == $s ?
}
}
close $fh or croak $?;
command_close_pipe($fh, $ctx);
});
}
# this isn't funky-filename safe, but good enough for now...
sub graft_file_copy_cmd {
my ($grafts, $l_map, $u) = @_;
my $paths = $l_map->{$u};
my $pfx = common_prefix([keys %$paths]);
$SVN_URL ||= $u.$pfx;
my $pid = open my $fh, '-|';
defined $pid or croak $!;
unless ($pid) {
my @exec = qw/svn log -v/;
push @exec, "-r$_revision" if defined $_revision;
exec @exec, $u.$pfx or croak $!;
}
my ($r, $mp) = (undef, undef);
while (<$fh>) {
chomp;
if (/^\-{72}$/) {
$mp = $r = undef;
} elsif (/^r(\d+) \| /) {
$r = $1 unless defined $r;
} elsif (/^Changed paths:/) {
$mp = 1;
} elsif ($mp && m#^ [AR] /(\S.*?) \(from /(\S+?):(\d+)\)$#) {
my ($p1, $p0, $r0) = ($1, $2, $3);
my $c = find_graft_path_commit($paths, $p1, $r);
next unless $c;
find_graft_path_parents($grafts, $paths, $c, $p0, $r0);
}
}
}
sub graft_file_copy_lib {
my ($grafts, $l_map, $u) = @_;
my $tree_paths = $l_map->{$u};
......@@ -1286,28 +1091,14 @@ sub graft_merge_msg {
sub read_uuid {
return if $SVN_UUID;
if ($_use_lib) {
my $pool = SVN::Pool->new;
$SVN_UUID = $SVN->get_uuid($pool);
$pool->clear;
} else {
my $info = shift || svn_info('.');
$SVN_UUID = $info->{'Repository UUID'} or
croak "Repository UUID unreadable\n";
}
my $pool = SVN::Pool->new;
$SVN_UUID = $SVN->get_uuid($pool);
$pool->clear;
}
sub quiet_run {
my $pid = fork;
defined $pid or croak $!;
if (!$pid) {
open my $null, '>', '/dev/null' or croak $!;
open STDERR, '>&', $null or croak $!;
open STDOUT, '>&', $null or croak $!;
exec @_ or croak $!;
}
waitpid $pid, 0;
return $?;
sub verify_ref {
my ($ref) = @_;
eval { command_oneline([ 'rev-parse', $ref ], { STDERR => 0 }) };
}
sub repo_path_split {
......@@ -1321,21 +1112,8 @@ sub repo_path_split {
return ($u, $full_url);
}
}
if ($_use_lib) {
my $tmp = libsvn_connect($full_url);
return ($tmp->{repos_root}, $tmp->{svn_path});
} else {
my ($url, $path) = ($full_url =~ m!^([a-z\+]+://[^/]*)(.*)$!i);
$path =~ s#^/+##;
my @paths = split(m#/+#, $path);
while (quiet_run(qw/svn ls --non-interactive/, $url)) {
my $n = shift @paths || last;
$url .= "/$n";
}
push @repo_path_split_cache, qr/^(\Q$url\E)/;
$path = join('/',@paths);
return ($url, $path);
}
my $tmp = libsvn_connect($full_url);
return ($tmp->{repos_root}, $tmp->{svn_path});
}
sub setup_git_svn {
......@@ -1351,41 +1129,17 @@ sub setup_git_svn {
}
sub assert_svn_wc_clean {
return if $_use_lib;
my ($svn_rev) = @_;
croak "$svn_rev is not an integer!\n" unless ($svn_rev =~ /^\d+$/);
my $lcr = svn_info('.')->{'Last Changed Rev'};
if ($svn_rev != $lcr) {
print STDERR "Checking for copy-tree ... ";
my @diff = grep(/^Index: /,(safe_qx(qw(svn diff),
"-r$lcr:$svn_rev")));
if (@diff) {
croak "Nope! Expected r$svn_rev, got r$lcr\n";
} else {
print STDERR "OK!\n";
}
}
my @status = grep(!/^Performing status on external/,(`svn status`));
@status = grep(!/^\s*$/,@status);
@status = grep(!/^X/,@status) if $_no_ignore_ext;
if (scalar @status) {
print STDERR "Tree ($SVN_WC) is not clean:\n";
print STDERR $_ foreach @status;
croak;
}
}
sub get_tree_from_treeish {
my ($treeish) = @_;
croak "Not a sha1: $treeish\n" unless $treeish =~ /^$sha1$/o;
chomp(my $type = `git-cat-file -t $treeish`);
my $type = command_oneline(qw/cat-file -t/, $treeish);
my $expected;
while ($type eq 'tag') {
chomp(($treeish, $type) = `git-cat-file tag $treeish`);
($treeish, $type) = command(qw/cat-file tag/, $treeish);
}
if ($type eq 'commit') {
$expected = (grep /^tree /,`git-cat-file commit $treeish`)[0];
$expected = (grep /^tree /, command(qw/cat-file commit/,
$treeish))[0];
($expected) = ($expected =~ /^tree ($sha1)$/);
die "Unable to get tree from $treeish\n" unless $expected;
} elsif ($type eq 'tree') {
......@@ -1396,27 +1150,19 @@ sub get_tree_from_treeish {
return $expected;
}
sub assert_tree {
return if $_use_lib;
my ($treeish) = @_;
my $expected = get_tree_from_treeish($treeish);
my $tmpindex = $GIT_SVN_INDEX.'.assert-tmp';
if (-e $tmpindex) {
unlink $tmpindex or croak $!;
}
my $old_index = set_index($tmpindex);
index_changes(1);
chomp(my $tree = `git-write-tree`);
restore_index($old_index);
if ($tree ne $expected) {
croak "Tree mismatch, Got: $tree, Expected: $expected\n";
sub get_diff {
my ($from, $treeish) = @_;
print "diff-tree $from $treeish\n";
my @diff_tree = qw(diff-tree -z -r);
if ($_cp_similarity) {
push @diff_tree, "-C$_cp_similarity";
} else {
push @diff_tree, '-C';
}
unlink $tmpindex;
}
sub parse_diff_tree {
my $diff_fh = shift;
push @diff_tree, '--find-copies-harder' if $_find_copies_harder;
push @diff_tree, "-l$_l" if defined $_l;
push @diff_tree, $from, $treeish;
my ($diff_fh, $ctx) = command_output_pipe(@diff_tree);
local $/ = "\0";
my $state = 'meta';
my @mods;
......@@ -1452,170 +1198,10 @@ sub parse_diff_tree {
croak "Error parsing $_\n";
}
}
close $diff_fh or croak $?;
command_close_pipe($diff_fh, $ctx);
return \@mods;
}
sub svn_check_prop_executable {
my $m = shift;
return if -l $m->{file_b};
if ($m->{mode_b} =~ /755$/) {
chmod((0755 &~ umask),$m->{file_b}) or croak $!;
if ($m->{mode_a} !~ /755$/) {
sys(qw(svn propset svn:executable 1), $m->{file_b});
}
-x $m->{file_b} or croak "$m->{file_b} is not executable!\n";
} elsif ($m->{mode_b} !~ /755$/ && $m->{mode_a} =~ /755$/) {
sys(qw(svn propdel svn:executable), $m->{file_b});
chmod((0644 &~ umask),$m->{file_b}) or croak $!;
-x $m->{file_b} and croak "$m->{file_b} is executable!\n";
}
}
sub svn_ensure_parent_path {
my $dir_b = dirname(shift);
svn_ensure_parent_path($dir_b) if ($dir_b ne File::Spec->curdir);
mkpath([$dir_b]) unless (-d $dir_b);
sys(qw(svn add -N), $dir_b) unless (-d "$dir_b/.svn");
}
sub precommit_check {
my $mods = shift;
my (%rm_file, %rmdir_check, %added_check);
my %o = ( D => 0, R => 1, C => 2, A => 3, M => 3, T => 3 );
foreach my $m (sort { $o{$a->{chg}} <=> $o{$b->{chg}} } @$mods) {
if ($m->{chg} eq 'R') {
if (-d $m->{file_b}) {
err_dir_to_file("$m->{file_a} => $m->{file_b}");
}
# dir/$file => dir/file/$file
my $dirname = dirname($m->{file_b});
while ($dirname ne File::Spec->curdir) {
if ($dirname ne $m->{file_a}) {
$dirname = dirname($dirname);
next;
}
err_file_to_dir("$m->{file_a} => $m->{file_b}");
}
# baz/zzz => baz (baz is a file)
$dirname = dirname($m->{file_a});
while ($dirname ne File::Spec->curdir) {
if ($dirname ne $m->{file_b}) {
$dirname = dirname($dirname);
next;
}
err_dir_to_file("$m->{file_a} => $m->{file_b}");
}
}
if ($m->{chg} =~ /^(D|R)$/) {
my $t = $1 eq 'D' ? 'file_b' : 'file_a';
$rm_file{ $m->{$t} } = 1;
my $dirname = dirname( $m->{$t} );
my $basename = basename( $m->{$t} );
$rmdir_check{$dirname}->{$basename} = 1;
} elsif ($m->{chg} =~ /^(?:A|C)$/) {
if (-d $m->{file_b}) {
err_dir_to_file($m->{file_b});
}
my $dirname = dirname( $m->{file_b} );
my $basename = basename( $m->{file_b} );
$added_check{$dirname}->{$basename} = 1;
while ($dirname ne File::Spec->curdir) {
if ($rm_file{$dirname}) {
err_file_to_dir($m->{file_b});
}
$dirname = dirname $dirname;
}
}
}
return (\%rmdir_check, \%added_check);
sub err_dir_to_file {
my $file = shift;
print STDERR "Node change from directory to file ",
"is not supported by Subversion: ",$file,"\n";
exit 1;
}
sub err_file_to_dir {
my $file = shift;
print STDERR "Node change from file to directory ",
"is not supported by Subversion: ",$file,"\n";
exit 1;
}
}
sub get_diff {
my ($from, $treeish) = @_;
assert_tree($from);
print "diff-tree $from $treeish\n";
my $pid = open my $diff_fh, '-|';
defined $pid or croak $!;
if ($pid == 0) {
my @diff_tree = qw(git-diff-tree -z -r);
if ($_cp_similarity) {
push @diff_tree, "-C$_cp_similarity";
} else {
push @diff_tree, '-C';
}
push @diff_tree, '--find-copies-harder' if $_find_copies_harder;
push @diff_tree, "-l$_l" if defined $_l;
exec(@diff_tree, $from, $treeish) or croak $!;
}
return parse_diff_tree($diff_fh);
}
sub svn_checkout_tree {
my ($from, $treeish) = @_;
my $mods = get_diff($from->{commit}, $treeish);
return $mods unless (scalar @$mods);
my ($rm, $add) = precommit_check($mods);
my %o = ( D => 1, R => 0, C => -1, A => 3, M => 3, T => 3 );
foreach my $m (sort { $o{$a->{chg}} <=> $o{$b->{chg}} } @$mods) {
if ($m->{chg} eq 'C') {
svn_ensure_parent_path( $m->{file_b} );
sys(qw(svn cp), $m->{file_a}, $m->{file_b});
apply_mod_line_blob($m);
svn_check_prop_executable($m);
} elsif ($m->{chg} eq 'D') {
sys(qw(svn rm --force), $m->{file_b});
} elsif ($m->{chg} eq 'R') {
svn_ensure_parent_path( $m->{file_b} );
sys(qw(svn mv --force), $m->{file_a}, $m->{file_b});
apply_mod_line_blob($m);
svn_check_prop_executable($m);
} elsif ($m->{chg} eq 'M') {
apply_mod_line_blob($m);
svn_check_prop_executable($m);
} elsif ($m->{chg} eq 'T') {
svn_check_prop_executable($m);
apply_mod_line_blob($m);
if ($m->{mode_a} =~ /^120/ && $m->{mode_b} !~ /^120/) {
sys(qw(svn propdel svn:special), $m->{file_b});
} else {
sys(qw(svn propset svn:special *),$m->{file_b});
}
} elsif ($m->{chg} eq 'A') {
svn_ensure_parent_path( $m->{file_b} );
apply_mod_line_blob($m);
sys(qw(svn add), $m->{file_b});
svn_check_prop_executable($m);
} else {
croak "Invalid chg: $m->{chg}\n";
}
}
assert_tree($treeish);
if ($_rmdir) { # remove empty directories
handle_rmdir($rm, $add);
}
assert_tree($treeish);
return $mods;
}
sub libsvn_checkout_tree {
my ($from, $treeish, $ed) = @_;
my $mods = get_diff($from, $treeish);
......@@ -1633,57 +1219,15 @@ sub libsvn_checkout_tree {
return $mods;
}
# svn ls doesn't work with respect to the current working tree, but what's
# in the repository. There's not even an option for it... *sigh*
# (added files don't show up and removed files remain in the ls listing)
sub svn_ls_current {
my ($dir, $rm, $add) = @_;
chomp(my @ls = safe_qx('svn','ls',$dir));
my @ret = ();
foreach (@ls) {
s#/$##; # trailing slashes are evil
push @ret, $_ unless $rm->{$dir}->{$_};
}
if (exists $add->{$dir}) {
push @ret, keys %{$add->{$dir}};
}
return \@ret;
}
sub handle_rmdir {
my ($rm, $add) = @_;
foreach my $dir (sort {length $b <=> length $a} keys %$rm) {
my $ls = svn_ls_current($dir, $rm, $add);
next if (scalar @$ls);
sys(qw(svn rm --force),$dir);
my $dn = dirname $dir;
$rm->{ $dn }->{ basename $dir } = 1;
$ls = svn_ls_current($dn, $rm, $add);
while (scalar @$ls == 0 && $dn ne File::Spec->curdir) {
sys(qw(svn rm --force),$dn);
$dir = basename $dn;
$dn = dirname $dn;
$rm->{ $dn }->{ $dir } = 1;
$ls = svn_ls_current($dn, $rm, $add);
}
}
}
sub get_commit_message {
my ($commit, $commit_msg) = (@_);
my %log_msg = ( msg => '' );
open my $msg, '>', $commit_msg or croak $!;
chomp(my $type = `git-cat-file -t $commit`);
my $type = command_oneline(qw/cat-file -t/, $commit);
if ($type eq 'commit' || $type eq 'tag') {
my $pid = open my $msg_fh, '-|';
defined $pid or croak $!;
if ($pid == 0) {
exec('git-cat-file', $type, $commit) or croak $!;
}
my ($msg_fh, $ctx) = command_output_pipe('cat-file',
$type, $commit);
my $in_msg = 0;
while (<$msg_fh>) {
if (!$in_msg) {
......@@ -1695,7 +1239,7 @@ sub get_commit_message {
print $msg $_ or croak $!;
}
}
close $msg_fh or croak $?;
command_close_pipe($msg_fh, $ctx);
}
close $msg or croak $!;
......@@ -1720,64 +1264,9 @@ sub set_svn_commit_env {
}
}
sub svn_commit_tree {
my ($last, $commit) = @_;
my $commit_msg = "$GIT_SVN_DIR/.svn-commit.tmp.$$";
my $log_msg = get_commit_message($commit, $commit_msg);
my ($oneline) = ($log_msg->{msg} =~ /([^\n\r]+)/);
print "Committing $commit: $oneline\n";
set_svn_commit_env();
my @ci_output = safe_qx(qw(svn commit -F),$commit_msg);
$ENV{LC_ALL} = 'C';
unlink $commit_msg;
my ($committed) = ($ci_output[$#ci_output] =~ /(\d+)/);
if (!defined $committed) {
my $out = join("\n",@ci_output);
print STDERR "W: Trouble parsing \`svn commit' output:\n\n",
$out, "\n\nAssuming English locale...";
($committed) = ($out =~ /^Committed revision \d+\./sm);
defined $committed or die " FAILED!\n",
"Commit output failed to parse committed revision!\n",
print STDERR " OK\n";
}
my @svn_up = qw(svn up);
push @svn_up, '--ignore-externals' unless $_no_ignore_ext;
if ($_optimize_commits && ($committed == ($last->{revision} + 1))) {
push @svn_up, "-r$committed";
sys(@svn_up);
my $info = svn_info('.');
my $date = $info->{'Last Changed Date'} or die "Missing date\n";
if ($info->{'Last Changed Rev'} != $committed) {
croak "$info->{'Last Changed Rev'} != $committed\n"
}
my ($Y,$m,$d,$H,$M,$S,$tz) = ($date =~
/(\d{4})\-(\d\d)\-(\d\d)\s
(\d\d)\:(\d\d)\:(\d\d)\s([\-\+]\d+)/x)
or croak "Failed to parse date: $date\n";
$log_msg->{date} = "$tz $Y-$m-$d $H:$M:$S";
$log_msg->{author} = $info->{'Last Changed Author'};
$log_msg->{revision} = $committed;
$log_msg->{msg} .= "\n";
$log_msg->{parents} = [ $last->{commit} ];
$log_msg->{commit} = git_commit($log_msg, $commit);
return $log_msg;
}
# resync immediately
push @svn_up, "-r$last->{revision}";
sys(@svn_up);
return fetch("$committed=$commit");
}
sub rev_list_raw {
my (@args) = @_;
my $pid = open my $fh, '-|';
defined $pid or croak $!;
if (!$pid) {
exec(qw/git-rev-list --pretty=raw/, @args) or croak $!;
}
return { fh => $fh, t => { } };
my ($fh, $c) = command_output_pipe(qw/rev-list --pretty=raw/, @_);
return { fh => $fh, ctx => $c, t => { } };
}
sub next_rev_list_entry {
......@@ -1799,184 +1288,10 @@ sub next_rev_list_entry {
$x->{m} .= $_;
}
}
command_close_pipe($fh, $rl->{ctx});
return ($x != $rl->{t}) ? $x : undef;
}
# read the entire log into a temporary file (which is removed ASAP)
# and store the file handle + parser state
sub svn_log_raw {
my (@log_args) = @_;
my $log_fh = IO::File->new_tmpfile or croak $!;
my $pid = fork;
defined $pid or croak $!;
if (!$pid) {
open STDOUT, '>&', $log_fh or croak $!;
exec (qw(svn log), @log_args) or croak $!
}
waitpid $pid, 0;
croak $? if $?;
seek $log_fh, 0, 0 or croak $!;
return { state => 'sep', fh => $log_fh };
}
sub next_log_entry {
my $log = shift; # retval of svn_log_raw()
my $ret = undef;
my $fh = $log->{fh};
while (<$fh>) {
chomp;
if (/^\-{72}$/) {
if ($log->{state} eq 'msg') {
if ($ret->{lines}) {
$ret->{msg} .= $_."\n";
unless(--$ret->{lines}) {
$log->{state} = 'sep';
}
} else {
croak "Log parse error at: $_\n",
$ret->{revision},
"\n";
}
next;
}
if ($log->{state} ne 'sep') {
croak "Log parse error at: $_\n",
"state: $log->{state}\n",
$ret->{revision},
"\n";
}
$log->{state} = 'rev';
# if we have an empty log message, put something there:
if ($ret) {
$ret->{msg} ||= "\n";
delete $ret->{lines};
return $ret;
}
next;
}
if ($log->{state} eq 'rev' && s/^r(\d+)\s*\|\s*//) {
my $rev = $1;
my ($author, $date, $lines) = split(/\s*\|\s*/, $_, 3);
($lines) = ($lines =~ /(\d+)/);
$date = '1970-01-01 00:00:00 +0000'
if ($_ignore_nodate && $date eq '(no date)');
my ($Y,$m,$d,$H,$M,$S,$tz) = ($date =~
/(\d{4})\-(\d\d)\-(\d\d)\s
(\d\d)\:(\d\d)\:(\d\d)\s([\-\+]\d+)/x)
or croak "Failed to parse date: $date\n";
$ret = { revision => $rev,
date => "$tz $Y-$m-$d $H:$M:$S",
author => $author,
lines => $lines,
msg => '' };
if (defined $_authors && ! defined $users{$author}) {
die "Author: $author not defined in ",
"$_authors file\n";
}
$log->{state} = 'msg_start';
next;
}
# skip the first blank line of the message:
if ($log->{state} eq 'msg_start' && /^$/) {
$log->{state} = 'msg';
} elsif ($log->{state} eq 'msg') {
if ($ret->{lines}) {
$ret->{msg} .= $_."\n";
unless (--$ret->{lines}) {
$log->{state} = 'sep';
}
} else {
croak "Log parse error at: $_\n",
$ret->{revision},"\n";
}
}
}
return $ret;
}
sub svn_info {
my $url = shift || $SVN_URL;
my $pid = open my $info_fh, '-|';
defined $pid or croak $!;
if ($pid == 0) {
exec(qw(svn info),$url) or croak $!;
}
my $ret = {};
# only single-lines seem to exist in svn info output
while (<$info_fh>) {
chomp $_;
if (m#^([^:]+)\s*:\s*(\S.*)$#) {
$ret->{$1} = $2;
push @{$ret->{-order}}, $1;
}
}
close $info_fh or croak $?;
return $ret;
}
sub sys { system(@_) == 0 or croak $? }
sub do_update_index {
my ($z_cmd, $cmd, $no_text_base) = @_;
my $z = open my $p, '-|';
defined $z or croak $!;
unless ($z) { exec @$z_cmd or croak $! }
my $pid = open my $ui, '|-';
defined $pid or croak $!;
unless ($pid) {
exec('git-update-index',"--$cmd",'-z','--stdin') or croak $!;
}
local $/ = "\0";
while (my $x = <$p>) {
chomp $x;
if (!$no_text_base && lstat $x && ! -l _ &&
svn_propget_base('svn:keywords', $x)) {
my $mode = -x _ ? 0755 : 0644;
my ($v,$d,$f) = File::Spec->splitpath($x);
my $tb = File::Spec->catfile($d, '.svn', 'tmp',
'text-base',"$f.svn-base");
$tb =~ s#^/##;
unless (-f $tb) {
$tb = File::Spec->catfile($d, '.svn',
'text-base',"$f.svn-base");
$tb =~ s#^/##;
}
my @s = stat($x);
unlink $x or croak $!;
copy($tb, $x);
chmod(($mode &~ umask), $x) or croak $!;
utime $s[8], $s[9], $x;
}
print $ui $x,"\0";
}
close $ui or croak $?;
}
sub index_changes {
return if $_use_lib;
if (!-f "$GIT_SVN_DIR/info/exclude") {
open my $fd, '>>', "$GIT_SVN_DIR/info/exclude" or croak $!;
print $fd '.svn',"\n";
close $fd or croak $!;
}
my $no_text_base = shift;
do_update_index([qw/git-diff-files --name-only -z/],
'remove',
$no_text_base);
do_update_index([qw/git-ls-files -z --others/,
"--exclude-from=$GIT_SVN_DIR/info/exclude"],
'add',
$no_text_base);
}
sub s_to_file {
my ($str, $file, $mode) = @_;
open my $fd,'>',$file or croak $!;
......@@ -2002,18 +1317,6 @@ sub assert_revision_unknown {
}
}
sub trees_eq {
my ($x, $y) = @_;
my @x = safe_qx('git-cat-file','commit',$x);
my @y = safe_qx('git-cat-file','commit',$y);
if (($y[0] ne $x[0]) || $x[0] !~ /^tree $sha1\n$/
|| $y[0] !~ /^tree $sha1\n$/) {
print STDERR "Trees not equal: $y[0] != $x[0]\n";
return 0
}
return 1;
}
sub git_commit {
my ($log_msg, @parents) = @_;
assert_revision_unknown($log_msg->{revision});
......@@ -2038,34 +1341,23 @@ sub git_commit {
my $tree = $log_msg->{tree};
if (!defined $tree) {
my $index = set_index($GIT_SVN_INDEX);
index_changes();
chomp($tree = `git-write-tree`);
$tree = command_oneline('write-tree');
croak $? if $?;
restore_index($index);
}
# just in case we clobber the existing ref, we still want that ref
# as our parent:
open my $null, '>', '/dev/null' or croak $!;
open my $stderr, '>&', \*STDERR or croak $!;
open STDERR, '>&', $null or croak $!;
if (my $cur = eval { safe_qx('git-rev-parse',
"refs/remotes/$GIT_SVN^0") }) {
if (my $cur = verify_ref("refs/remotes/$GIT_SVN^0")) {
chomp $cur;
push @tmp_parents, $cur;
}
open STDERR, '>&', $stderr or croak $!;
close $stderr or croak $!;
close $null or croak $!;
if (exists $tree_map{$tree}) {
foreach my $p (@{$tree_map{$tree}}) {
my $skip;
foreach (@tmp_parents) {
# see if a common parent is found
my $mb = eval {
safe_qx('git-merge-base', $_, $p)
};
my $mb = eval { command('merge-base', $_, $p) };
next if ($@ || $?);
$skip = 1;
last;
......@@ -2107,7 +1399,7 @@ sub git_commit {
if ($commit !~ /^$sha1$/o) {
die "Failed to commit, invalid sha1: $commit\n";
}
sys('git-update-ref',"refs/remotes/$GIT_SVN",$commit);
command_noisy('update-ref',"refs/remotes/$GIT_SVN",$commit);
revdb_set($REVDB, $log_msg->{revision}, $commit);
# this output is read via pipe, do not change:
......@@ -2119,7 +1411,8 @@ sub git_commit {
sub check_repack {
if ($_repack && (--$_repack_nr == 0)) {
$_repack_nr = $_repack;
sys("git repack $_repack_flags");
# repack doesn't use any arguments with spaces in them, does it?
command_noisy('repack', split(/\s+/, $_repack_flags));
}
}
......@@ -2136,122 +1429,17 @@ sub set_commit_env {
$ENV{GIT_AUTHOR_DATE} = $ENV{GIT_COMMITTER_DATE} = $log_msg->{date};
}
sub apply_mod_line_blob {
my $m = shift;
if ($m->{mode_b} =~ /^120/) {
blob_to_symlink($m->{sha1_b}, $m->{file_b});
} else {
blob_to_file($m->{sha1_b}, $m->{file_b});
}
}
sub blob_to_symlink {
my ($blob, $link) = @_;
defined $link or croak "\$link not defined!\n";
croak "Not a sha1: $blob\n" unless $blob =~ /^$sha1$/o;
if (-l $link || -f _) {
unlink $link or croak $!;
}
my $dest = `git-cat-file blob $blob`; # no newline, so no chomp
symlink $dest, $link or croak $!;
}
sub blob_to_file {
my ($blob, $file) = @_;
defined $file or croak "\$file not defined!\n";
croak "Not a sha1: $blob\n" unless $blob =~ /^$sha1$/o;
if (-l $file || -f _) {
unlink $file or croak $!;
}
open my $blob_fh, '>', $file or croak "$!: $file\n";
my $pid = fork;
defined $pid or croak $!;
if ($pid == 0) {
open STDOUT, '>&', $blob_fh or croak $!;
exec('git-cat-file','blob',$blob) or croak $!;
}
waitpid $pid, 0;
croak $? if $?;
close $blob_fh or croak $!;
}
sub safe_qx {
my $pid = open my $child, '-|';
defined $pid or croak $!;
if ($pid == 0) {
exec(@_) or croak $!;
}
my @ret = (<$child>);
close $child or croak $?;
die $? if $?; # just in case close didn't error out
return wantarray ? @ret : join('',@ret);
}
sub svn_compat_check {
if ($_follow_parent) {
print STDERR 'E: --follow-parent functionality is only ',
"available when SVN libraries are used\n";
exit 1;
}
my @co_help = safe_qx(qw(svn co -h));
unless (grep /ignore-externals/,@co_help) {
print STDERR "W: Installed svn version does not support ",
"--ignore-externals\n";
$_no_ignore_ext = 1;
}
if (grep /usage: checkout URL\[\@REV\]/,@co_help) {
$_svn_co_url_revs = 1;
}
if (grep /\[TARGET\[\@REV\]\.\.\.\]/, `svn propget -h`) {
$_svn_pg_peg_revs = 1;
}
# I really, really hope nobody hits this...
unless (grep /stop-on-copy/, (safe_qx(qw(svn log -h)))) {
print STDERR <<'';
W: The installed svn version does not support the --stop-on-copy flag in
the log command.
Lets hope the directory you're tracking is not a branch or tag
and was never moved within the repository...
$_no_stop_copy = 1;
}
}
# *sigh*, new versions of svn won't honor -r<rev> without URL@<rev>,
# (and they won't honor URL@<rev> without -r<rev>, too!)
sub svn_cmd_checkout {
my ($url, $rev, $dir) = @_;
my @cmd = ('svn','co', "-r$rev");
push @cmd, '--ignore-externals' unless $_no_ignore_ext;
$url .= "\@$rev" if $_svn_co_url_revs;
sys(@cmd, $url, $dir);
}
sub check_upgrade_needed {
if (!-r $REVDB) {
-d $GIT_SVN_DIR or mkpath([$GIT_SVN_DIR]);
open my $fh, '>>',$REVDB or croak $!;
close $fh;
}
my $old = eval {
my $pid = open my $child, '-|';
defined $pid or croak $!;
if ($pid == 0) {
close STDERR;
exec('git-rev-parse',"$GIT_SVN-HEAD") or croak $!;
}
my @ret = (<$child>);
close $child or croak $?;
die $? if $?; # just in case close didn't error out
return wantarray ? @ret : join('',@ret);
return unless eval {
command([qw/rev-parse --verify/,"$GIT_SVN-HEAD^0"],
{STDERR => 0});
};
return unless $old;
my $head = eval { safe_qx('git-rev-parse',"refs/remotes/$GIT_SVN") };
my $head = eval { command('rev-parse',"refs/remotes/$GIT_SVN") };
if ($@ || !$head) {
print STDERR "Please run: $0 rebuild --upgrade\n";
exit 1;
......@@ -2263,12 +1451,8 @@ sub check_upgrade_needed {
sub map_tree_joins {
my %seen;
foreach my $br (@_branch_from) {
my $pid = open my $pipe, '-|';
defined $pid or croak $!;
if ($pid == 0) {
exec(qw(git-rev-list --topo-order --pretty=raw), $br)
or croak $!;
}
my $pipe = command_output_pipe(qw/rev-list
--topo-order --pretty=raw/, $br);
while (<$pipe>) {
if (/^commit ($sha1)$/o) {
my $commit = $1;
......@@ -2284,7 +1468,7 @@ sub map_tree_joins {
$seen{$commit} = 1;
}
}
close $pipe; # we could be breaking the pipe early
eval { command_close_pipe($pipe) };
}
}
......@@ -2296,7 +1480,7 @@ sub load_all_refs {
# don't worry about rev-list on non-commit objects/tags,
# it shouldn't blow up if a ref is a blob or tree...
chomp(@_branch_from = `git-rev-parse --symbolic --all`);
@_branch_from = command(qw/rev-parse --symbolic --all/);
}
# '<svn username> = real-name <email address>' mapping based on git-svnimport:
......@@ -2322,15 +1506,9 @@ sub rload_authors {
close $authors or croak $!;
}
sub svn_propget_base {
my ($p, $f) = @_;
$f .= '@BASE' if $_svn_pg_peg_revs;
return safe_qx(qw/svn propget/, $p, $f);
}
sub git_svn_each {
my $sub = shift;
foreach (`git-rev-parse --symbolic --all`) {
foreach (command(qw/rev-parse --symbolic --all/)) {
next unless s#^refs/remotes/##;
chomp $_;
next unless -f "$GIT_DIR/svn/$_/info/url";
......@@ -2371,7 +1549,7 @@ sub migration_check {
"$GIT_SVN_DIR\n\t(required for this version ",
"($VERSION) of git-svn) does not.\n";
foreach my $x (`git-rev-parse --symbolic --all`) {
foreach my $x (command(qw/rev-parse --symbolic --all/)) {
next unless $x =~ s#^refs/remotes/##;
chomp $x;
next unless -f "$GIT_DIR/$x/info/url";
......@@ -2476,11 +1654,7 @@ sub write_grafts {
my $p = $grafts->{$c};
my %x; # real parents
delete $p->{$c}; # commits are not self-reproducing...
my $pid = open my $ch, '-|';
defined $pid or croak $!;
if (!$pid) {
exec(qw/git-cat-file commit/, $c) or croak $!;
}
my $ch = command_output_pipe(qw/cat-file commit/, $c);
while (<$ch>) {
if (/^parent ($sha1)/) {
$x{$1} = $p->{$1} = 1;
......@@ -2488,7 +1662,7 @@ sub write_grafts {
last unless /^\S/;
}
}
close $ch; # breaking the pipe
eval { command_close_pipe($ch) }; # breaking the pipe
# if real parents are the only ones in the grafts, drop it
next if join(' ',sort keys %$p) eq join(' ',sort keys %x);
......@@ -2500,7 +1674,7 @@ sub write_grafts {
next if $del{$i} || $p->{$i} == 2;
foreach my $j (@jp) {
next if $i eq $j || $del{$j} || $p->{$j} == 2;
$mb = eval { safe_qx('git-merge-base',$i,$j) };
$mb = eval { command('merge-base', $i, $j) };
next unless $mb;
chomp $mb;
next if $x{$mb};
......@@ -2571,15 +1745,12 @@ sub extract_metadata {
sub cmt_metadata {
return extract_metadata((grep(/^git-svn-id: /,
safe_qx(qw/git-cat-file commit/, shift)))[-1]);
command(qw/cat-file commit/, shift)))[-1]);
}
sub get_commit_time {
my $cmt = shift;
defined(my $pid = open my $fh, '-|') or croak $!;
if (!$pid) {
exec qw/git-rev-list --pretty=raw -n1/, $cmt or croak $!;
}
my $fh = command_output_pipe(qw/rev-list --pretty=raw -n1/, $cmt);
while (<$fh>) {
/^committer\s(?:.+) (\d+) ([\-\+]?\d+)$/ or next;
my ($s, $tz) = ($1, $2);
......@@ -2588,7 +1759,7 @@ sub get_commit_time {
} elsif ($tz =~ s/^\-//) {
$s -= tz_to_s_offset($tz);
}
close $fh;
eval { command_close_pipe($fh) };
return $s;
}
die "Can't get commit time for commit: $cmt\n";
......@@ -2734,34 +1905,6 @@ sub show_commit_normal {
}
}
sub libsvn_load {
return unless $_use_lib;
$_use_lib = eval {
require SVN::Core;
if ($SVN::Core::VERSION lt '1.1.0') {
die "Need SVN::Core 1.1.0 or better ",
"(got $SVN::Core::VERSION) ",
"Falling back to command-line svn\n";
}
require SVN::Ra;
require SVN::Delta;
push @SVN::Git::Editor::ISA, 'SVN::Delta::Editor';
push @SVN::Git::Fetcher::ISA, 'SVN::Delta::Editor';
*SVN::Git::Fetcher::process_rm = *process_rm;
*SVN::Git::Fetcher::safe_qx = *safe_qx;
my $kill_stupid_warnings = $SVN::Node::none.$SVN::Node::file.
$SVN::Node::dir.$SVN::Node::unknown.
$SVN::Node::none.$SVN::Node::file.
$SVN::Node::dir.$SVN::Node::unknown.
$SVN::Auth::SSL::CNMISMATCH.
$SVN::Auth::SSL::NOTYETVALID.
$SVN::Auth::SSL::EXPIRED.
$SVN::Auth::SSL::UNKNOWNCA.
$SVN::Auth::SSL::OTHER;
1;
};
}
sub _simple_prompt {
my ($cred, $realm, $default_username, $may_save, $pool) = @_;
$may_save = undef if $_no_auth_cache;
......@@ -2965,7 +2108,7 @@ sub libsvn_get_file {
my $mode = exists $props->{'svn:executable'} ? '100755' : '100644';
if (exists $props->{'svn:special'}) {
$mode = '120000';
my $link = `git-cat-file blob $hash`;
my $link = `git-cat-file blob $hash`; # no chomping symlinks
$link =~ s/^link // or die "svn:special file with contents: <",
$link, "> is not understood\n";
defined($pid = open3($in, $out, '>&STDERR',
......@@ -3069,19 +2212,17 @@ sub libsvn_log_entry {
sub process_rm {
my ($gui, $last_commit, $f, $q) = @_;
# remove entire directories.
if (safe_qx('git-ls-tree',$last_commit,'--',$f) =~ /^040000 tree/) {
defined(my $pid = open my $ls, '-|') or croak $!;
if (!$pid) {
exec(qw/git-ls-tree -r --name-only -z/,
$last_commit,'--',$f) or croak $!;
}
if (command('ls-tree',$last_commit,'--',$f) =~ /^040000 tree/) {
my ($ls, $ctx) = command_output_pipe(qw/ls-tree
-r --name-only -z/,
$last_commit,'--',$f);
local $/ = "\0";
while (<$ls>) {
print $gui '0 ',0 x 40,"\t",$_ or croak $!;
print "\tD\t$_\n" unless $q;
}
print "\tD\t$f/\n" unless $q;
close $ls or croak $?;
command_close_pipe($ls, $ctx);
return $SVN::Node::dir;
} else {
print $gui '0 ',0 x 40,"\t",$f,"\0" or croak $!;
......@@ -3112,7 +2253,7 @@ sub libsvn_fetch_delta {
sub libsvn_fetch_full {
my ($last_commit, $paths, $rev, $author, $date, $msg) = @_;
open my $gui, '| git-update-index -z --index-info' or croak $!;
my ($gui, $ctx) = command_input_pipe(qw/update-index -z --index-info/);
my %amr;
my $ut = { empty => {}, dir_prop => {}, file_prop => {} };
my $p = $SVN->{svn_path};
......@@ -3166,20 +2307,14 @@ sub libsvn_fetch_full {
%{$ut->{dir_prop}->{''}} = %$props;
$pool->clear;
}
close $gui or croak $?;
command_close_pipe($gui, $ctx);
libsvn_log_entry($rev, $author, $date, $msg, [$last_commit], $ut);
}
sub svn_grab_base_rev {
defined(my $pid = open my $fh, '-|') or croak $!;
if (!$pid) {
open my $null, '>', '/dev/null' or croak $!;
open STDERR, '>&', $null or croak $!;
exec qw/git-rev-parse --verify/,"refs/remotes/$GIT_SVN^0"
or croak $!;
}
chomp(my $c = do { local $/; <$fh> });
close $fh;
my $c = eval { command_oneline([qw/rev-parse --verify/,
"refs/remotes/$GIT_SVN^0"],
{ STDERR => 0 }) };
if (defined $c && length $c) {
my ($url, $rev, $uuid) = cmt_metadata($c);
return ($rev, $c) if defined $rev;
......@@ -3292,18 +2427,11 @@ sub revisions_eq {
my ($path, $r0, $r1) = @_;
return 1 if $r0 == $r1;
my $nr = 0;
if ($_use_lib) {
# should be OK to use Pool here (r1 - r0) should be small
my $pool = SVN::Pool->new;
libsvn_get_log($SVN, [$path], $r0, $r1,
0, 0, 1, sub {$nr++}, $pool);
$pool->clear;
} else {
my ($url, undef) = repo_path_split($SVN_URL);
my $svn_log = svn_log_raw("$url/$path","-r$r0:$r1");
while (next_log_entry($svn_log)) { $nr++ }
close $svn_log->{fh};
}
# should be OK to use Pool here (r1 - r0) should be small
my $pool = SVN::Pool->new;
libsvn_get_log($SVN, [$path], $r0, $r1,
0, 0, 1, sub {$nr++}, $pool);
$pool->clear;
return 0 if ($nr > 1);
return 1;
}
......@@ -3358,7 +2486,7 @@ sub libsvn_find_parent_branch {
if (revisions_eq($branch_from, $r0, $r)) {
unlink $GIT_SVN_INDEX;
print STDERR "Found branch parent: ($GIT_SVN) $parent\n";
sys(qw/git-read-tree/, $parent);
command_noisy('read-tree', $parent);
unless (libsvn_can_do_switch()) {
return libsvn_fetch_full($parent, $paths, $rev,
$author, $date, $msg);
......@@ -3367,7 +2495,7 @@ sub libsvn_find_parent_branch {
# included with SVN 1.4.2 (the latest version at the moment),
# so we can't rely on it.
my $ra = libsvn_connect("$url/$branch_from");
my $ed = SVN::Git::Fetcher->new({c => $parent, q => $_q});
my $ed = SVN::Git::Fetcher->new({c => $parent, q => $_q });
my $pool = SVN::Pool->new;
my $reporter = $ra->do_switch($rev, '', 1, $SVN->{url},
$ed, $pool);
......@@ -3413,9 +2541,10 @@ sub libsvn_new_tree {
$ut = $ed;
} else {
$ut = { empty => {}, dir_prop => {}, file_prop => {} };
open my $gui, '| git-update-index -z --index-info' or croak $!;
my ($gui, $ctx) = command_input_pipe(qw/update-index
-z --index-info/);
libsvn_traverse($gui, '', $SVN->{svn_path}, $rev, undef, $ut);
close $gui or croak $?;
command_close_pipe($gui, $ctx);
}
libsvn_log_entry($rev, $author, $date, $msg, [], $ut);
}
......@@ -3487,7 +2616,7 @@ sub libsvn_commit_cb {
my $log = libsvn_log_entry($rev,$committer,$date,$msg);
$log->{tree} = get_tree_from_treeish($c);
my $cmt = git_commit($log, $cmt_last, $c);
my @diff = safe_qx('git-diff-tree', $cmt, $c);
my @diff = command('diff-tree', $cmt, $c);
if (@diff) {
print STDERR "Trees differ: $cmt $c\n",
join('',@diff),"\n";
......@@ -3579,27 +2708,40 @@ sub revdb_get {
sub copy_remote_ref {
my $origin = $_cp_remote ? $_cp_remote : 'origin';
my $ref = "refs/remotes/$GIT_SVN";
if (safe_qx('git-ls-remote', $origin, $ref)) {
sys(qw/git fetch/, $origin, "$ref:$ref");
if (command('ls-remote', $origin, $ref)) {
command_noisy('fetch', $origin, "$ref:$ref");
} elsif ($_cp_remote && !$_upgrade) {
die "Unable to find remote reference: ",
"refs/remotes/$GIT_SVN on $origin\n";
}
}
{
my $kill_stupid_warnings = $SVN::Node::none.$SVN::Node::file.
$SVN::Node::dir.$SVN::Node::unknown.
$SVN::Node::none.$SVN::Node::file.
$SVN::Node::dir.$SVN::Node::unknown.
$SVN::Auth::SSL::CNMISMATCH.
$SVN::Auth::SSL::NOTYETVALID.
$SVN::Auth::SSL::EXPIRED.
$SVN::Auth::SSL::UNKNOWNCA.
$SVN::Auth::SSL::OTHER;
}
package SVN::Git::Fetcher;
use vars qw/@ISA/;
use strict;
use warnings;
use Carp qw/croak/;
use IO::File qw//;
use Git qw/command command_oneline command_noisy
command_output_pipe command_input_pipe command_close_pipe/;
# file baton members: path, mode_a, mode_b, pool, fh, blob, base
sub new {
my ($class, $git_svn) = @_;
my $self = SVN::Delta::Editor->new;
bless $self, $class;
open my $gui, '| git-update-index -z --index-info' or croak $!;
$self->{gui} = $gui;
$self->{c} = $git_svn->{c} if exists $git_svn->{c};
$self->{q} = $git_svn->{q};
$self->{empty} = {};
......@@ -3607,6 +2749,8 @@ sub new {
$self->{file_prop} = {};
$self->{absent_dir} = {};
$self->{absent_file} = {};
($self->{gui}, $self->{ctx}) = command_input_pipe(
qw/update-index -z --index-info/);
require Digest::MD5;
$self;
}
......@@ -3629,7 +2773,7 @@ sub delete_entry {
sub open_file {
my ($self, $path, $pb, $rev) = @_;
my ($mode, $blob) = (safe_qx('git-ls-tree',$self->{c},'--',$path)
my ($mode, $blob) = (command('ls-tree', $self->{c}, '--',$path)
=~ /^(\d{6}) blob ([a-f\d]{40})\t/);
unless (defined $mode && defined $blob) {
die "$path was not found in commit $self->{c} (r$rev)\n";
......@@ -3764,13 +2908,13 @@ sub close_file {
sub abort_edit {
my $self = shift;
close $self->{gui};
eval { command_close_pipe($self->{gui}, $self->{ctx}) };
$self->SUPER::abort_edit(@_);
}
sub close_edit {
my $self = shift;
close $self->{gui} or croak $!;
command_close_pipe($self->{gui}, $self->{ctx});
$self->{git_commit_ok} = 1;
$self->SUPER::close_edit(@_);
}
......@@ -3781,6 +2925,8 @@ package SVN::Git::Editor;
use warnings;
use Carp qw/croak/;
use IO::File;
use Git qw/command command_oneline command_noisy
command_output_pipe command_input_pipe command_close_pipe/;
sub new {
my $class = shift;
......@@ -3830,10 +2976,8 @@ sub rmdirs {
delete $rm->{''}; # we never delete the url we're tracking
return unless %$rm;
defined(my $pid = open my $fh,'-|') or croak $!;
if (!$pid) {
exec qw/git-ls-tree --name-only -r -z/, $self->{c} or croak $!;
}
my ($fh, $ctx) = command_output_pipe(
qw/ls-tree --name-only -r -z/, $self->{c});
local $/ = "\0";
while (<$fh>) {
chomp;
......@@ -3842,11 +2986,11 @@ sub rmdirs {
delete $rm->{join '/', @dn};
}
unless (%$rm) {
close $fh;
eval { command_close_pipe($fh) };
return;
}
}
close $fh;
command_close_pipe($fh, $ctx);
my ($r, $p, $bat) = ($self->{r}, $self->{pool}, $self->{bat});
foreach my $d (sort { $b =~ tr#/#/# <=> $a =~ tr#/#/# } keys %$rm) {
......@@ -4021,13 +3165,7 @@ sub abort_edit {
Data structures:
$svn_log hashref (as returned by svn_log_raw)
{
fh => file handle of the log file,
state => state of the log file parser (sep/msg/rev/msg_start...)
}
$log_msg hashref as returned by next_log_entry($svn_log)
$log_msg hashref as returned by libsvn_log_entry()
{
msg => 'whitespace-formatted log entry
', # trailing newline is preserved
......@@ -4036,7 +3174,6 @@ sub abort_edit {
author => 'committer name'
};
@mods = array of diff-index line hashes, each element represents one line
of diff-index output
......
......@@ -23,13 +23,9 @@ clean:
# we can test NO_OPTIMIZE_COMMITS independently of LC_ALL
full-svn-test:
$(MAKE) $(TSVN) GIT_SVN_NO_LIB=0 GIT_SVN_DELTA_FETCH=1 \
GIT_SVN_NO_OPTIMIZE_COMMITS=1 LC_ALL=C
$(MAKE) $(TSVN) GIT_SVN_NO_LIB=1 GIT_SVN_NO_OPTIMIZE_COMMITS=1 LC_ALL=C
$(MAKE) $(TSVN) GIT_SVN_NO_LIB=1 GIT_SVN_NO_OPTIMIZE_COMMITS=0 \
LC_ALL=en_US.UTF-8
$(MAKE) $(TSVN) GIT_SVN_NO_LIB=0 GIT_SVN_NO_OPTIMIZE_COMMITS=0 \
LC_ALL=en_US.UTF-8
$(MAKE) $(TSVN) GIT_SVN_DELTA_FETCH=1 \
GIT_SVN_NO_OPTIMIZE_COMMITS=1 LC_ALL=C
$(MAKE) $(TSVN) GIT_SVN_NO_OPTIMIZE_COMMITS=0 LC_ALL=en_US.UTF-8
.PHONY: $(T) clean
.NOTPARALLEL:
......
......@@ -7,17 +7,18 @@ then
exit
fi
GIT_DIR=$PWD/.git
GIT_SVN_DIR=$GIT_DIR/svn/git-svn
SVN_TREE=$GIT_SVN_DIR/svn-tree
perl -e 'use SVN::Core' >/dev/null 2>&1
perl -e 'use SVN::Core; $SVN::Core::VERSION gt "1.1.0" or die' >/dev/null 2>&1
if test $? -ne 0
then
echo 'Perl SVN libraries not found, tests requiring those will be skipped'
GIT_SVN_NO_LIB=1
test_expect_success 'Perl SVN libraries not found, skipping test' :
test_done
exit
fi
GIT_DIR=$PWD/.git
GIT_SVN_DIR=$GIT_DIR/svn/git-svn
SVN_TREE=$GIT_SVN_DIR/svn-tree
svnadmin >/dev/null 2>&1
if test $? -ne 1
then
......
......@@ -56,7 +56,7 @@ git update-index --add --remove dir/a/b/c/d/e/file dir/file file
git commit -m "$name"
test_expect_success "$name" \
"git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch &&
"git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch &&
svn up $SVN_TREE &&
test -d $SVN_TREE/dir && test ! -d $SVN_TREE/dir/a"
......@@ -70,7 +70,7 @@ git update-index --add dir/file/file
git commit -m "$name"
test_expect_failure "$name" \
'git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch' \
'git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch' \
|| true
......@@ -85,7 +85,7 @@ git update-index --add -- bar
git commit -m "$name"
test_expect_failure "$name" \
'git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch2' \
'git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch2' \
|| true
......@@ -100,7 +100,7 @@ git-update-index --add bar/zzz/yyy
git commit -m "$name"
test_expect_failure "$name" \
'git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch3' \
'git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch3' \
|| true
......@@ -115,7 +115,7 @@ git update-index --add -- dir
git commit -m "$name"
test_expect_failure "$name" \
'git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch4' \
'git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch4' \
|| true
......@@ -127,7 +127,7 @@ git update-index exec.sh
git commit -m "$name"
test_expect_success "$name" \
"git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
"git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
svn up $SVN_TREE &&
test ! -x $SVN_TREE/exec.sh"
......@@ -138,7 +138,7 @@ git update-index exec.sh
git commit -m "$name"
test_expect_success "$name" \
"git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
"git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
svn up $SVN_TREE &&
test -x $SVN_TREE/exec.sh"
......@@ -153,7 +153,7 @@ then
git commit -m "$name"
test_expect_success "$name" \
"git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
"git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
svn up $SVN_TREE &&
test -L $SVN_TREE/exec.sh"
......@@ -164,7 +164,7 @@ then
git commit -m "$name"
test_expect_success "$name" \
"git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
"git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
svn up $SVN_TREE &&
test -x $SVN_TREE/bar/zzz &&
test -L $SVN_TREE/exec-2.sh"
......@@ -177,7 +177,7 @@ then
git commit -m "$name"
test_expect_success "$name" \
"git-svn commit --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
"git-svn set-tree --find-copies-harder --rmdir remotes/git-svn..mybranch5 &&
svn up $SVN_TREE &&
test -f $SVN_TREE/exec-2.sh &&
test ! -L $SVN_TREE/exec-2.sh &&
......@@ -192,7 +192,7 @@ then
git update-index exec-2.sh
git commit -m 'éï∏'
export LC_ALL="$GIT_SVN_LC_ALL"
test_expect_success "$name" "git-svn commit HEAD"
test_expect_success "$name" "git-svn set-tree HEAD"
unset LC_ALL
else
echo "UTF-8 locale not set, test skipped ($GIT_SVN_LC_ALL)"
......@@ -229,9 +229,7 @@ tree d667270a1f7b109f5eb3aaea21ede14b56bfdd6e
tree 8f51f74cf0163afc9ad68a4b1537288c4558b5a4
EOF
if test -z "$GIT_SVN_NO_LIB" || test "$GIT_SVN_NO_LIB" -eq 0; then
echo tree 4b825dc642cb6eb9a060e54bf8d69288fbee4904 >> expected
fi
echo tree 4b825dc642cb6eb9a060e54bf8d69288fbee4904 >> expected
test_expect_success "$name" "diff -u a expected"
......
......@@ -74,7 +74,7 @@ test_expect_success "$name" \
'git checkout -b mybranch remotes/git-svn &&
echo Hi again >> kw.c &&
git commit -a -m "test keywoards ignoring" &&
git-svn commit remotes/git-svn..mybranch &&
git-svn set-tree remotes/git-svn..mybranch &&
git pull . remotes/git-svn'
expect='/* $Id$ */'
......
......@@ -21,7 +21,7 @@ test_expect_success 'mirror via git-svn' "
test_expect_success 'Try a commit on rmdir' "
git rm -f deeply/nested/directory/number/2/another &&
git commit -a -m 'remove another' &&
git-svn commit --rmdir HEAD &&
git-svn set-tree --rmdir HEAD &&
svn ls -R $svnrepo | grep ^deeply/nested/directory/number/1
"
......
......@@ -6,13 +6,6 @@
test_description='git-svn --follow-parent fetching'
. ./lib-git-svn.sh
if test -n "$GIT_SVN_NO_LIB" && test "$GIT_SVN_NO_LIB" -ne 0
then
echo 'Skipping: --follow-parent needs SVN libraries'
test_done
exit 0
fi
test_expect_success 'initialize repo' "
mkdir import &&
cd import &&
......
......@@ -4,13 +4,6 @@
test_description='git-svn commit-diff'
. ./lib-git-svn.sh
if test -n "$GIT_SVN_NO_LIB" && test "$GIT_SVN_NO_LIB" -ne 0
then
echo 'Skipping: commit-diff needs SVN libraries'
test_done
exit 0
fi
test_expect_success 'initialize repo' "
mkdir import &&
cd import &&
......
......@@ -4,13 +4,6 @@
test_description='git-svn commit-diff clobber'
. ./lib-git-svn.sh
if test -n "$GIT_SVN_NO_LIB" && test "$GIT_SVN_NO_LIB" -ne 0
then
echo 'Skipping: commit-diff clobber needs SVN libraries'
test_done
exit 0
fi
test_expect_success 'initialize repo' "
mkdir import &&
cd import &&
......
Markdown is supported
0% .
You are about to add 0 people to the discussion. Proceed with caution.
先完成此消息的编辑!
想要评论请 注册